%define         perversion      1.-94.-2
Name:           clc-intercal
Version:        0
Release:        0.1.%(echo %{perversion}|sed -e's/-/_/g')%{?dist}
Summary:        Compiler for the INTERCAL language
License:        BSD
Group:          Development/Libraries
URL:            http://intercal.freeshell.org/
Source0:        http://intercal.freeshell.org/download/CLC-INTERCAL-%{perversion}/CLC-INTERCAL-%{perversion}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  perl(Curses)
BuildRequires:  perl(Gtk2)

%description
This package provides a Perl-based compiler for the INTERCAL programming
language, usable either from the command line or as a Perl module.

CLC-INTERCAL is designed to be almost compatible with the original (Princeton
1972) compiler. It also implements several extensions to the original language,
including support for object orientation, operator overloading and quantum
computing. 

%package        UI-X
Summary:        Graphical user interface to CLC-INTERCAL
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description    UI-X
This package installs a graphical user interface to CLC-INTERCAL.

At present, only the INTERCAL calculator, "intercalc", uses this interface,
although a future release of "sick" will be able to use it as well.


%prep
%setup -q -n CLC-INTERCAL-%{perversion}

cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
sed -e '/perl(MY)/d'
EOF

%define __perl_provides %{_builddir}/CLC-INTERCAL-%{perversion}/%{name}-prov
chmod +x %{__perl_provides}



%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
# parallel build fails - don't use -j
make

%install
rm -rf %{buildroot}

make install PERL_INSTALL_ROOT=%{buildroot}

find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} %{buildroot}/*
find %{buildroot} -type f -name \*.pm | xargs chmod 644

# manually install documentation
mkdir -p %{buildroot}%{_docdir}/%{name}-%{perversion}
cp -p CLC-INTERCAL-Base-%{perversion}/{Changes,COPYING,MISSING,README,WISHLIST} \
  %{buildroot}%{_docdir}/%{name}-%{perversion}
for pkg in Docs ICALC INET UI-Curses UI-Line UI-X; do
  cp -p CLC-INTERCAL-${pkg}-%{perversion}/Changes \
    %{buildroot}%{_docdir}/%{name}-%{perversion}/Changes-${pkg}
  cp -p CLC-INTERCAL-${pkg}-%{perversion}/README \
    %{buildroot}%{_docdir}/%{name}-%{perversion}/README-${pkg}
done
cp -ap CLC-INTERCAL-Docs-%{perversion}/doc/{examples,html,INTERNET} \
  %{buildroot}%{_docdir}/%{name}-%{perversion}

# convert "bookworm" and "change" characters to utf-8 friendly versions
for doc in $(find %{buildroot}%{_docdir}/%{name}-%{perversion}/{examples,INTERNET} -type f); do
  sed -i -e 's/\o245/V\o010-/g' -e 's/\o242/c\o010\//g' $doc
done

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%docdir %{_docdir}/%{name}-%{perversion}
%{_docdir}/%{name}-%{perversion}
%exclude %{_docdir}/%{name}-%{perversion}/*-UI-X
%{perl_vendorlib}/*
%exclude %{perl_vendorlib}/Language/INTERCAL/Interface/X.pm
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man3/*

%files UI-X
%defattr(-,root,root,-)
%{_docdir}/%{name}-%{perversion}/*-UI-X
%{perl_vendorlib}/Language/INTERCAL/Interface/X.pm


%changelog
* Thu Jan 29 2009 Iain Arnell <iarnell@gmail.com> 0-0.0.1._94._2
- pre-pre-escape 1.-94.-2

